"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var fs_1 = require("fs");
var async_mutex_1 = require("async-mutex");
var is_valid_path_1 = __importDefault(require("is-valid-path"));
var FileData = /** @class */ (function () {
    function FileData(path) {
        this.path = path;
        if (!is_valid_path_1["default"](path)) {
            throw new Error("Invalid filesystem path: " + path);
        }
    }
    FileData.prototype.read = function () {
        return __awaiter(this, void 0, void 0, function () {
            var json, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.data) {
                            return [2 /*return*/, this.data];
                        }
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, fs_1.promises.readFile(this.path, 'utf-8')];
                    case 2:
                        json = _a.sent();
                        return [2 /*return*/, (this.data = JSON.parse(json))];
                    case 3:
                        e_1 = _a.sent();
                        if (e_1.code === 'ENOENT') {
                            return [2 /*return*/, (this.data = {})];
                        }
                        else {
                            throw e_1;
                        }
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    FileData.prototype.write = function () {
        return __awaiter(this, void 0, void 0, function () {
            var json;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        json = JSON.stringify(this.data || {});
                        return [4 /*yield*/, fs_1.promises.writeFile(this.path, json, 'utf-8')];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    return FileData;
}());
var FileStoreAdapter = /** @class */ (function () {
    function FileStoreAdapter(path) {
        this.mutex = new async_mutex_1.Mutex();
        this.fileData = new FileData(path);
    }
    FileStoreAdapter.prototype.del = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileData.read()];
                    case 1:
                        data = _a.sent();
                        delete data[key];
                        return [4 /*yield*/, this.fileData.write()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    FileStoreAdapter.prototype.get = function (key) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileData.read()];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data[key]];
                }
            });
        });
    };
    FileStoreAdapter.prototype.list = function () {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileData.read()];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, Object.keys(data)];
                }
            });
        });
    };
    FileStoreAdapter.prototype.set = function (key, value) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fileData.read()];
                    case 1:
                        data = _a.sent();
                        data[key] = value;
                        return [4 /*yield*/, this.fileData.write()];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, value];
                }
            });
        });
    };
    FileStoreAdapter.prototype.update = function (key, updater) {
        return __awaiter(this, void 0, void 0, function () {
            var release, data, val, oldValue, newValue;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.mutex.acquire()];
                    case 1:
                        release = _a.sent();
                        _a.label = 2;
                    case 2:
                        _a.trys.push([2, , 7, 8]);
                        return [4 /*yield*/, this.fileData.read()];
                    case 3:
                        data = _a.sent();
                        val = data[key];
                        oldValue = typeof val === 'object' ? __assign({}, val) : val;
                        return [4 /*yield*/, updater(oldValue)];
                    case 4:
                        newValue = _a.sent();
                        if (!(newValue !== undefined)) return [3 /*break*/, 6];
                        data[key] = newValue;
                        return [4 /*yield*/, this.fileData.write()];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [2 /*return*/, [oldValue, newValue]];
                    case 7:
                        release();
                        return [7 /*endfinally*/];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    return FileStoreAdapter;
}());
exports["default"] = FileStoreAdapter;
//# sourceMappingURL=FileStoreAdapter.js.map