import { PersistentStoreAdapter, Updater } from './types';
export default class PersistentStore {
    private prefix;
    private adapter;
    constructor(backend: PersistentStore | PersistentStoreAdapter, prefix?: string);
    del(key: string): Promise<void>;
    get(key: string): Promise<any>;
    list(): Promise<string[]>;
    set(key: string, value: any): Promise<any>;
    update(key: string, updater: Updater): Promise<any[]>;
    validateKey(key: string): void;
    validateValue(value: any): void;
}
